﻿using Owin;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;

namespace Demo.Owin.Hosting
{
    class AppBuilder : IAppBuilder
    {
        private readonly IDictionary<string, object> props;

        private readonly List<AppFunc> registeredMiddlewareObjects;

        public AppBuilder()
        {
            this.props = new Dictionary<string, object>();
            this.registeredMiddlewareObjects = new List<AppFunc>();
        }

        public object Build(Type returnType)
        {
            throw new NotImplementedException();
        }

        public IAppBuilder New()
        {
            throw new NotImplementedException();
        }

        public IDictionary<string, object> Properties
        {
            get { return this.props; }
        }

        public List<AppFunc> RegisteredMiddlewareObjects
        {
            get { return this.registeredMiddlewareObjects; }
        }

        public IAppBuilder Use(object middleware, params object[] args)
        {
            var type = middleware.GetType();
            var flags = BindingFlags.Instance | BindingFlags.Public;
            var methods = type.GetMethods(flags);

            // TODO: call method "void Initialize(AppFunc next, ...)" with "args"

            var q = from m in methods
                    where m.Name == "Invoke"
                    let p = m.GetParameters()
                    where (p.Length == 1) && (p[0].ParameterType == typeof(IDictionary<string, object>)) && (m.ReturnType == typeof(Task))
                    select m;

            var candidate = q.FirstOrDefault();

            if (candidate != null)
            {
                var appFunc = Delegate.CreateDelegate(typeof(AppFunc), middleware, candidate) as AppFunc;
                this.registeredMiddlewareObjects.Add(appFunc);
            }

            return this;
        }
    }
}
