﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LightweightWebLib
{
    using AppFunc = Func<IDictionary<string, object>, Task>;
    
    public class LightweightModule
    {
        public LightweightModule()
        {
        }

        public void Initialize(AppFunc next)
        {
            // TODO: add chaining
        }

        public Task Invoke(IDictionary<string, object> environment)
        {
            return Task.Factory.StartNew(this.ProcessRequestInternal, environment);
        }

        private void ProcessRequestInternal(object environment)
        {
            var env = environment as IDictionary<string, object>;

            var req = new Request(env);
            var res = new Response(env);

            this.ProcessRequest(req, res);
        }

        private void ProcessRequest(Request req, Response res)
        {
            this.Write(res, "Hello OWIN");
            this.Write(res, "<p>Path=" + req.Path + "</p>");
            this.Write(res, "<p>QueryString=" + req.QueryString + "</p>");

            res.StatusCode = 200;
        }

        private void Write(Response res, string s)
        {
            var buff = Encoding.Default.GetBytes(s);
            
            res.Body.Write(buff, 0, buff.Length);
        }
    }
}
